#!/bin/bash

NAME_SCRIPT=`echo $0 | rev | cut -d'/' -f1  | cut -d'.' -f2 | rev`
NAME=`pwd | rev | cut -d'/' -f1  | rev`
[ -z $IT ] && IT=5            # Repeticiones
[ -z $TMP_DIR ] && TMP_DIR=/dev/shm

PATH=.:$PATH

[ -z "$N" ] && N="1000 2000 3000"
rm ${NAME_SCRIPT}.resultados 2>/dev/null
echo -e "\nCompiladon implementación (sin Blas)"
gcc $NAME.c -march=native -fomit-frame-pointer -O2 -lm -o $NAME

echo "Determinando el mejor tamaño de bloque"

for n in $N ; do
   B=$(for i in `seq 10 10 1000` ; do echo $i `echo "$n/$i" | bc -l` ; done | grep ".00000000000000000000" | cut -d' ' -f1)
   for b in $B ; do
	echo -e "${n}\n${n}\n${n}\n${b}\n" | $NAME 2>/dev/null | tee -a ${NAME_SCRIPT}.resultados
   done
done

echo
