#!/bin/bash

[ -z $TMP_DIR ] && TMP_DIR=/dev/shm
NAME=`pwd | rev | cut -d'/' -f1  | rev`

F=${NAME}_busca_tam.resultados
[ -z "$N" ] && N="1000 2000 3000"

rm $TMP_DIR/* 2>/dev/null

COLOR=1
PLOT=''
for n in $N ; do
	FILE=$TMP_DIR/${F}_N$n
	PLOT="$PLOT, \"${FILE}\" using 1:2 with linespoints title \"N=${n}\" $COLOR"
	COLOR=$(($COLOR+1))
	cat $F | grep "N=$n," | sed "s|.* B=\(.*\), N=.*, S=\(.*\)$|\1 \2|g" >$FILE
done
PLOT=`echo $PLOT | cut -c2-`

cat <<__EOF__ | gnuplot
set terminal pdf
set output "${NAME}_busca_tam.pdf"
set xlabel "Bloque"
set ylabel "Segundos"
set xtics (10,20,30,40,50,60,80,100,120,150,200,250,300,400,500,600,750,1000)
set key left top
set logscale x
set logscale y
set title "Multiplicar matrices por bloques"
plot $PLOT
__EOF__


rm $TMP_DIR/* 2>/dev/null

