#!/bin/bash

[ -z $IT ] && IT=5            # Repeticiones
[ -z $TMP_DIR ] && TMP_DIR=/dev/shm
NAME=`pwd | rev | cut -d'/' -f1  | rev`

[ -z "$N" ] && N="1000 2000 3000"
rm *.resultados 2>/dev/null
echo -e "\nCompiladon implementación (sin Blas)"
gcc $NAME.c -march=native -fomit-frame-pointer -O2 -lm -o $NAME

for n in $N ; do
	OUT=$TMP_DIR/${NAME}_N$n
	rm $F 2>/dev/null
	echo -n "Ejecutando $NAME con N=$n"

	for i in `seq 1 $IT` ; do
		echo -n "."
		echo -e "${n}\n${n}\n${n}\n" | ./$NAME 2>/dev/null >>$OUT
	done
	echo

	MEDIA=$(echo scale=7\; \(`cat $OUT | sed "s|.*, S=\(.*\)|\1|g" | tr "\n" "+"`0\) / $IT | bc -l)
	MEDIA=`echo $MEDIA | sed "s|^\.|0.|g"`
	rm $OUT

	echo "[$NAME] N=$n, S=$MEDIA" >> ${NAME}.resultados
done
