#!/bin/bash

[ -z "$N" ] && N="1000 2000 3000"
NT=`echo "$N" | tr " " "\n" | wc -l`
DIRS="directa bloques mb1 mb2 mb3"

OUT=Blas.tex
echo '\begin{table}' >$OUT
echo '\begin{center}' >>$OUT
echo -n '\begin{tabular}{|' >>$OUT
for i in 0 $N ; do 
  echo -n 'c|' >>$OUT
done
echo "} \cline{2-$(($NT+1))}" >>$OUT
echo "\multicolumn{1}{c}{} & \multicolumn{$NT}{|>{\\color{white}\\columncolor[gray]{.4}}c|}{N}\\\ \\cline{1-$(($NT+1))}" >>$OUT

echo -n "\multicolumn{1}{|>{\\color{white}\\columncolor[gray]{.4}}c|}{Versión}" >>$OUT

for n in $N ; do
  echo -n " & \\multicolumn{1}{>{\\columncolor[gray]{.9}}c|}{$n}" >>$OUT
done

echo '\\ \hline' >>$OUT

for F in `find $DIRS -name '*.resultados' | grep -v bloques_busca_tam` ; do
  NAME=`echo $F | cut -d'.' -f1 | cut -d/ -f2 | tr "_" " "`

  echo -n "\\cellcolor[gray]{.9} $NAME " >>$OUT
  for n in $N ; do
	FILAS=`cat "$F" | grep " N=$n, "`
	CELDA=`echo "$FILAS" | cut -d'=' -f3`
	echo -n "& $CELDA " >>$OUT
  done
  echo '\\ \hline' >>$OUT
done

L=`echo $F | cut -d'.' -f1 | tr '_' ' '`

echo '\end{tabular}' >>$OUT
echo "\\end{center}\\caption[Mediciones BLAS]{Mediciones con BLAS}" >>$OUT
echo "\\end{table}\\label{tab: Blas}" >>$OUT
