#!/bin/bash

[ -z $TMP_DIR ] && TMP_DIR=/dev/shm
NAME=`pwd | rev | cut -d'/' -f1  | rev`
[ -z "$N" ] && N="1000 2000 3000"
BLAS_VERSION=`echo $NAME | rev | cut -c1 | rev`
NORMAL_FILE=../directa/directa.resultados

DATA=`cat *.resultados | sed "s|\[${NAME}_\(.*\)\] N=\(.*\), S=\(.*\)$|\1 \2 \3|g"`

for n in $N ; do
	FILE=$TMP_DIR/$NAME$_N$n
	NORMAL_DATA=`cat $NORMAL_FILE | grep " N=$n, " | cut -d= -f3`
	echo "$DATA" | grep " $n " >$FILE

	cat <<__EOF__ | gnuplot
set terminal pdf
set output "${NAME}_N$n.pdf"
set ylabel "Segundos"
set title "BLAS nivel ${BLAS_VERSION}, N=$n"
set style data histogram
set style histogram cluster gap 1
set style fill solid border -1
set boxwidth 1
set xtic rotate by -45
plot "${FILE}" using 3:xtic(1) title "BLAS-${BLAS_VERSION}", \
     $NORMAL_DATA title "Directa"
__EOF__
done


rm $TMP_DIR/* 2>/dev/null

