#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

int main(int argc, char **argv)
{
  double *a,*b,*c;
  int fa,ca,lda,fb,cb,ldb,fc,cc,ldc,tb;
  
  int ti1,tf1,si,sf;
  struct timeval *tv;
  struct timezone *tz;

  tv=(struct timeval *) malloc(sizeof(struct timeval));
  tz=(struct timezone *) malloc(sizeof(struct timezone));

  scanf("%d",&fa);
  scanf("%d",&ca);
  lda=ca;
  fb=ca;
  scanf("%d",&cb);
  ldb=cb;
  fc=fa;
  cc=cb;
  ldc=cc;
  scanf("%d",&tb);

  a=(double *) malloc(sizeof(double)*fa*ca);
  b=(double *) malloc(sizeof(double)*fb*cb);
  c=(double *) malloc(sizeof(double)*fc*cc);

  generar(a,fa,ca,lda);
  generar(b,fb,cb,ldb);
  
  gettimeofday(tv,tz);
  si=(tv->tv_sec);
  ti1=(tv->tv_usec);
  ti1=si*1000000+ti1;

  multbloques(a,fa,ca,lda,b,fb,cb,ldb,c,fc,cc,ldc,tb);

  gettimeofday(tv,tz);
  sf=(tv->tv_sec);

  tf1=(tv->tv_usec);
  tf1=sf*1000000+tf1;
  //printf("Tamao matriz %d, bloque %d: %.6f seg\n",fa,tb,(tf1-ti1)/1000000.);
  printf("[%s] B=%d, N=%d, S=%.6f\n", argv[0], tb, fa,(tf1-ti1)/1000000.);

  escribir(c,fc,cc,ldc);
 
  free(tv);
  free(tz);
  free(a);
  free(b);
  free(c);
}

generar(m,fm,cm,ldm)
double *m;
int fm,cm,ldm;
{
  int i,j;

  for(i=0;i<fm;i++)
  {
    for(j=0;j<cm;j++)
    {
      m[i*ldm+j]=(double) (i+j);
    }
  }
  return(m[10]);
}

escribir(m,fm,cm,ldm)
double *m;
int fm,cm,ldm;
{
/*  int i,j;

  for(i=0;i<fm;i++)
  {
    for(j=0;j<cm;j++)
    {
      fprintf(stderr, "%.4f ",m[i*ldm+j]);
    }
    fprintf(stderr, "\n");
  }*/
}

multbloques(a,fa,ca,lda,b,fb,cb,ldb,c,fc,cc,ldc,tb)
double *a;
int fa,ca,lda;
double *b;
int fb,cb,ldb;
double *c;
int fc,cc,ldc,tb;
{
  int i,j,k;
  double *s;

  s=(double *) malloc(sizeof(double)*tb*tb);

  for(i=0;i<fa;i=i+tb)
  {
    for(j=0;j<cb;j=j+tb)
    {
      ceros(s,tb,tb,tb);
      for(k=0;k<ca;k=k+tb)
      {
        multsumar(&a[i*lda+k],tb,tb,lda,&b[k*ldb+j],tb,tb,ldb,s,tb,tb,tb);
      }
      copiar(s,tb,tb,tb,&c[i*ldc+j],tb,tb,ldc);
    }
  }
  free(s);
}

ceros(m,fm,cm,ldm)
double *m;
int fm,cm,ldm;
{
  int i,j;
  double *dm;

  for(i=0;i<fm;i++)
  {
    dm=&m[i*ldm];
    for(j=0;j<cm;j++)
    {
      dm[j]=0.;
    }
  }
}

copiar(mo,fmo,cmo,ldmo,md,fmd,cmd,ldmd)
double *mo;
int fmo,cmo,ldmo;
double *md;
int fmd,cmd,ldmd;
{
  int i,j;
  double *dmo,*dmd;

  for(i=0;i<fmo;i++)
  {
    dmo=&mo[i*ldmo];
    dmd=&md[i*ldmd];
    for(j=0;j<cmo;j++)
    {
      dmd[j]=dmo[j];
    }
  }
}

multsumar(a,fa,ca,lda,b,fb,cb,ldb,c,fc,cc,ldc)
double *a;
int fa,ca,lda;
double *b;
int fb,cb,ldb;
double *c;
int fc,cc,ldc;
{
  int i,j,k,kb;
  double *da,*db,s;

  for(i=0;i<fa;i++)
  {
    da=&a[i*lda];
    for(j=0;j<cb;j++)
    {
      db=&b[j];
      s=c[i*ldc+j];
      for(k=0,kb=0;k<ca;k++,kb=kb+ldb)
      {
        s=s+da[k]*db[kb];
      }
      c[i*ldc+j]=s;
    }
  }
}

