#!/bin/bash

[ -z $TMP_DIR ] && TMP_DIR=/dev/shm
NAME=`pwd | rev | cut -d'/' -f1  | rev`
N="500 1000 1500"

SORT_DIR="directa bloques mb1 mb2 mb3"
DATA=$(find $SORT_DIR -name '*.resultados' ! -name '*busca_tam*' -exec cat "{}" \; \
       | sed "s|\[\(.*\)\] N=\(.*\), S=\(.*\)$|\1 \2 \3|g" \
       | sed "s|mb\([1-3]\)_|blas\1-|g" )

PLOT=''
for n in $N ; do
	FILE=$TMP_DIR/$NAME$_N$n
	echo "$DATA" | grep " $n " >$FILE
	PLOT="$PLOT, \"${FILE}\" using 3:xtic(1) title \"N=${n}\""
done
PLOT=`echo $PLOT | cut -c2-`

cat <<__EOF__ | gnuplot
set terminal pdf
set output "${NAME}.pdf"
set ylabel "Segundos"
#set key left top
set logscale y
set title "Multiplica"
set style data histogram
set style histogram cluster gap 1
set style fill solid border -1
set boxwidth 0.9
set xtic rotate by -45
plot $PLOT
__EOF__


rm $TMP_DIR/* 2>/dev/null

