#!/bin/bash

BASENAME=mb1
N="500 1000 1500"
DIR_TMP=/dev/shm
IT=5

rm *.resultados 2>/dev/null

for imp in `ls /usr/lib/blas/` ; do

   echo -e "\nUsando la implementación de $imp"
   export LD_LIBRARY_PATH=/usr/lib64/blas/$imp
   NAME=${BASENAME}_${imp}

   gcc $BASENAME.c -march=native -fomit-frame-pointer -O2 -lblas -lm -o $NAME
   ldd $NAME | grep libblas


   for n in $N ; do
	  OUT=$DIR_TMP/${NAME}_N$n
	  rm $F 2>/dev/null
	  echo -n "Ejecutando $NAME con N=$n "

	  for i in `seq 1 $IT` ; do
		echo -n "."
		echo -e "${n}\n${n}\n${n}\n" | ./$NAME 2>/dev/null >>$OUT
	  done
	  echo

	  MEDIA=$(echo scale=7\; \(`cat $OUT | sed "s|.*, S=\(.*\)|\1|g" | tr "\n" "+"`0\) / $IT | bc -l)
	  MEDIA=`echo $MEDIA | sed "s|^\.|0.|g"`
	  rm $OUT

	  echo "[$NAME] N=$n, S=$MEDIA" >> ${NAME}.resultados
   done

done
