#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#include <stdio.h>
#include <stdio.h>
#include <stdlib.h>

extern void dgemv_();

int main(int argc, char **argv)
{
  double *a,*b,*c;
  int fa,ca,lda,fb,cb,ldb,fc,cc,ldc;

  void generar(),escribir(),mult();

  int ti1,tf1,si,sf;
  struct timeval *tv;
  struct timezone *tz;

  tv=(struct timeval *) malloc(sizeof(struct timeval));
  tz=(struct timezone *) malloc(sizeof(struct timezone));

  scanf("%d",&fa);
  scanf("%d",&ca);
  lda=ca;
  fb=ca;
  scanf("%d",&cb);
  ldb=cb;
  fc=fa;
  cc=cb;
  ldc=cc;

  a=(double *) malloc(sizeof(double)*fa*ca);
  b=(double *) malloc(sizeof(double)*fb*cb);
  c=(double *) malloc(sizeof(double)*fc*cc);

  generar(a,fa,ca,lda);
  generar(b,fb,cb,ldb);
  escribir(a,fa,ca,lda);
  escribir(b,fb,cb,ldb);
 
  gettimeofday(tv,tz);
  si=(tv->tv_sec);
  ti1=(tv->tv_usec);
  ti1=si*1000000+ti1;

  mult(a,fa,ca,lda,b,fb,cb,ldb,c,fc,cc,ldc);

  gettimeofday(tv,tz);
  sf=(tv->tv_sec);
  tf1=(tv->tv_usec);
  tf1=sf*1000000+tf1;
  printf("[%s] N=%d, S=%.6f\n", argv[0], fa,(tf1-ti1)/1000000.);

  escribir(c,fc,cc,ldc);

  free(tv);
  free(tz);
  free(a);
  free(b);
  free(c);
}

void generar(m,fm,cm,ldm)
double *m;
int fm,cm,ldm;
{
  int i,j;

  for(i=0;i<fm;i++)
  {
    for(j=0;j<cm;j++)
    {
      m[i*ldm+j]=(double) (i+j);
    }
  }
}

void escribir(m,fm,cm,ldm)
double *m;
int fm,cm,ldm;
{
   int i,j;

  for(i=0;i<fm;i++)
  {
    for(j=0;j<cm;j++)
    {
      fprintf(stderr, "%.4f ",m[i*ldm+j]);
    }
    fprintf(stderr, "\n");
  }
}

void mult(a,fa,ca,lda,b,fb,cb,ldb,c,fc,cc,ldc)
double *a;
int fa,ca,lda;
double *b;
int fb,cb,ldb;
double *c;
int fc,cc,ldc;
{
  int i;
  double uno=1.,cero=0.;

  for(i=0;i<cb;i++)
  {
    dgemv_("t",&ca,&fa,&uno,a,&lda,&b[i],&ldb,&cero,&c[i],&ldc);
  }
}

