#!/bin/bash

[ -z $TMP_DIR ] && TMP_DIR=/dev/shm
NAME=`pwd | rev | cut -d'/' -f1  | rev`

rm $TMP_DIR/* 2>/dev/null

COLOR=0
PLOT=''
for imp in `ls /usr/lib64/lapack/` ; do
   for p in dgetrf dgetf2 ; do
	FILE=$TMP_DIR/$NAME.$imp.$p
	cat ${NAME}_${imp}-$p.resultados | sed "s|\[${NAME}_.*\] N=\(.*\), S=\(.*\)|\1 \2|g" > $FILE
	COLOR=$(($COLOR+1))
	PLOT="$PLOT, \"${FILE}\" using 1:2 with linespoints title \"$p ($imp)\" $COLOR"
   done
done

PLOT=`echo $PLOT | cut -c2-`

cat <<__EOF__ | gnuplot
set terminal pdf
set output "${NAME}.pdf"
set key left top
set xlabel "N"
set ylabel "Segundos"
set title "LU con Lapack"
plot $PLOT
__EOF__

for p in dgetrf dgetf2 ; do
  COLOR=0
  PLOT2=''
  for imp in `ls /usr/lib64/lapack/` ; do
	FILE=$TMP_DIR/$NAME.$imp.$p
	COLOR=$(($COLOR+1))
	PLOT2="$PLOT2, \"${FILE}\" using 1:2 with linespoints title \"$p ($imp)\" $COLOR"
  done
  PLOT2=`echo $PLOT2 | cut -c2-`

  cat <<__EOF__ | gnuplot
set terminal pdf
set output "${NAME}_$p.pdf"
#set logscale y
set key left top
set xlabel "N"
set ylabel "Segundos"
set title "LU $p"
plot $PLOT2
__EOF__
done

rm $TMP_DIR/* 2>/dev/null
