#!/bin/bash

F1=`ls *.resultados | grep reference | grep dgetf2`
F2=`ls *.resultados | grep reference | grep dgetrf`
F3=`ls *.resultados | grep atlas | grep dgetf2`
F4=`ls *.resultados | grep atlas | grep dgetrf`
F="$F1 $F2 $F3 $F4"
FN=4

N=`cat $F1 | cut -d= -f2 | cut -d, -f1`
NT=`echo "$N" | tr " " "\n" | wc -l`

NAME=lu
OUT=$NAME.tex

echo '\begin{table}' >$OUT
echo '\begin{center}' >>$OUT
echo -n '\begin{tabular}{|' >>$OUT
for i in `seq 0 $FN` ; do 
	echo -n 'c|' >>$OUT
done
echo "} \cline{2-$(($FN+1))}" >>$OUT
echo "\multicolumn{1}{c}{} & \multicolumn{$FN}{|>{\\color{white}\\columncolor[gray]{.4}}c|}{N}\\\ \\cline{1-$(($FN+1))}" >>$OUT

echo -n "\multicolumn{1}{|>{\\color{white}\\columncolor[gray]{.4}}c|}{N}" >>$OUT

for f in $F ; do
	ALIAS=`echo $f | cut -d. -f1 | cut -c4-`
	echo -n " & \\multicolumn{1}{>{\\columncolor[gray]{.9}}c|}{$ALIAS}" >>$OUT
done

echo '\\ \hline' >>$OUT

for n in $N ; do
	echo -n "\\cellcolor[gray]{.9} $n " >>$OUT
	for f in $F ; do
		FILAS=`cat "$f" | grep " N=$n, "`
		CELDA=`echo "$FILAS" | cut -d'=' -f3`
		echo -n "& $CELDA " >>$OUT
	done
	echo '\\ \hline' >>$OUT
done

echo '\end{tabular}' >>$OUT
echo "\\end{center}\\caption[$NAME]{$NAME}" >>$OUT
echo "\\end{table}\\label{tab:$NAME}" >>$OUT
