#!/bin/bash

[ -z $IT ] && IT=5            # Repeticiones
[ -z $TMP_DIR ] && TMP_DIR=/dev/shm
BASENAME=`pwd | rev | cut -d'/' -f1  | rev`

[ -z "$PARMS" ] && PARMS="500 4000 100"

PATH=.:$PATH

rm *.resultados 2>/dev/null

for imp in `ls /usr/lib64/lapack/` ; do

   echo -e "\nUsando la implementación de $imp"
   export LD_LIBRARY_PATH=/usr/lib64/blas/${imp}:/usr/lib64/lapack/${imp}
   NAME=${BASENAME}_${imp}

   gcc $BASENAME.c -march=native -fomit-frame-pointer -O2 -llapack -lblas -lm -o $NAME
   ldd $NAME | egrep "(blas|lapack)"
   
   OUT=$TMP_DIR/${NAME}
   rm $OUT 2>/dev/null

   echo -n "Lanzando ejecución "
   for i in `seq 1 $IT` ; do
 	echo -n "."
	$NAME $PARMS 2>/dev/null >>$OUT
   done
   echo

   N=`cat $OUT | cut -d= -f3 | cut -d, -f1 | sort | uniq`
   
   for p in dgetrf dgetf2 ; do
   	for n in $N ; do
		DATA=`cat $OUT | grep "N=$n," | grep $p`
		MEDIA=$(echo scale=7\; \(`echo "$DATA" | sed "s|.*, S=\(.*\)|\1|g" | tr "\n" "+"`0\) / $IT | bc -l)
		MEDIA=`echo $MEDIA | sed "s|^\.|0.|g"`
		echo "[$NAME] N=$n, S=$MEDIA" >> ${NAME}-$p.resultados
	done
   done
   rm $OUT
done
