#!/bin/bash

[ -z $TMP_DIR ] && TMP_DIR=/dev/shm
NAME=`pwd | rev | cut -d'/' -f1  | rev`

F=${NAME}.resultados
[ -z "$N" ] && N="1000 2000 3000"

rm $TMP_DIR/* 2>/dev/null

COLOR=1
PLOT=''
for n in $N ; do
	FILE=$TMP_DIR/${F}_N$n
	PLOT="$PLOT, \"${FILE}\" using 1:2 with linespoints title \"N=${n}\" $COLOR"
	COLOR=$(($COLOR+1))
	cat $F | grep "N=$n," | sed "s|.* P=\(.*\), N=.*, S=\(.*\)$|\1 \2|g" >$FILE
done
PLOT=`echo $PLOT | cut -c2-`

cat <<__EOF__ | gnuplot
set terminal pdf
set output "${NAME}.pdf"
set xlabel "Nodos"
set ylabel "Segundos"
set title "Multiplica matrices con MPI"
plot $PLOT
__EOF__


rm $TMP_DIR/* 2>/dev/null

