#!/bin/bash

NAME=`pwd | rev | cut -d'/' -f1  | rev`
FILE="$NAME.resultados"
P="2 3 4 5 6"
NP=5

MAX_N=`cat $FILE | cut -d= -f3 | uniq | cut -d, -f1 | tail -n1`

DATA=`cat $FILE | grep "N=${MAX_N}, "`

tn=`echo "$DATA" | grep "P=1," | cut -d= -f4`

echo '\begin{table}'
echo '\begin{center}'
echo '\begin{tabular}{|c|c|c|c|} \cline{1-4}'
echo '\cellcolor[gray]{.9} $p$ &'
echo '\cellcolor[gray]{.9} Speedup $S(n,p)$ &'
echo '\cellcolor[gray]{.9} Eficiencia $E(n,p)$ &'
echo '\cellcolor[gray]{.9} Coste $C(n,p)$ \\ \hline'

for p in 2 3 4 5 6 ; do
	tnp=`echo "$DATA" | grep "P=$p," | cut -d= -f4`
	snp=`echo "$tn / $tnp" | bc -l | sed "s|^\.\([0-9]*\)|0.\1|g"`
	enp=`echo "$snp / $p" | bc -l | sed "s|^\.\([0-9]*\)|0.\1|g"`
	cnp=`echo "$tnp * $p" | bc -l | sed "s|^\.\([0-9]*\)|0.\1|g"`
	echo "\\cellcolor[gray]{.9} $p & $snp & $enp & $cnp \\\\ \\hline"
done

echo '\end{tabular}'
echo "\\end{center}\\caption[Speedup, eficiencia y coste de $NAME]{Speedup, eficiencia y coste de $NAME con n=$MAX_N. El valor del tiempo secuencial \$t(n)=$tn\$ segundos}"
echo "\\end{table}\\label{tab:speedup_eficiancia_coste_$NAME}"
