#!/bin/bash

[ -z $TMP_DIR ] && TMP_DIR=/dev/shm

NAME=`pwd | rev | cut -d'/' -f1  | rev`
CONFIG="`cat ${NAME}.conf | egrep -v '(^#|^$)'`"
WC=`echo "$CONFIG" | wc -l`

[ -z "$N" ] && N="10000000 20000000 40000000"

rm $TMP_DIR/MPI_* 2>/dev/null

PRIMIT_LIST=`cat *.resultados | sed "s|\[\(.*\)\] .*|\1|g" | uniq`

for n in $N ; do
	PLOT=''
	COLOR=1
	RES=`cat *.resultados | grep ", N=$n" | sed "s|\[\(.*\)\] P=\(.*\), .*, S=\(.*\)|\1 \2 \3|g"`
	for m in $PRIMIT_LIST ; do
		PRIMIT=$(echo $m | tr "/" "_")
		F=$TMP_DIR/MPI_${PRIMIT}_$n
		echo "$RES" | grep $m >$F
		COLOR=$(($COLOR+1))
		PLOT="$PLOT, \"$F\" using 2:3 with linespoints title \"$m\" $COLOR"
	done
	PLOT=`echo $PLOT | cut -c3-`

cat <<__EOF__ | gnuplot
set terminal pdf
set output "${NAME}_N$n.pdf"
set xlabel "Nodos"
set ylabel "Segundos"
set key left top
set title "Primitivas MPI, N=$n enteros"
#set logscale y
plot $PLOT
__EOF__

done


rm $TMP_DIR/MPI_* 2>/dev/null

