#!/bin/bash

[ -z $TMP_DIR ] && TMP_DIR=/dev/shm
[ "x$LOG_SCALE" == "x1" ] && LOG_FILE='_logY' && LOG_STR='set logscale y'
NAME=`pwd | rev | cut -d'/' -f1  | rev`

for c in gcc icc ; do
  for o in -O2 -O3 -Os ; do
	
	# Un grafico con distingos CFLAGS en un compilador determinado
	F=${NAME}_$c${o}-MEDIA.resultados
	OUT="$TMP_DIR/data_${c}${o}_MEDIA"
	cat $F | sed "s|.* P=\(.*\), N=MEDIA, S=\(.*\)|\1 \2|g" > $OUT

  done
done

for c in gcc icc ; do
# Graficos comparando gcc y icc para cada tamagno
	cat <<__EOF__ | gnuplot
set terminal pdf
set output "${NAME}_${c}_MEDIA$LOG_FILE.pdf"
set key right bottom
set xlabel "Threads"
set ylabel "Segundos"
$LOG_STR
set title "${NAME}, $c"
#set xtics 1
plot "$TMP_DIR/data_${c}-O2_MEDIA" using 1:2 with linespoints title "-O2" 1 ,\
     "$TMP_DIR/data_${c}-O3_MEDIA" using 1:2 with linespoints title "-O3" 2 ,\
     "$TMP_DIR/data_${c}-Os_MEDIA" using 1:2 with linespoints title "-Os" 3
__EOF__
done

rm $TMP_DIR/data_*
