#!/bin/bash

FILE=$1

if [ $# == 0 ] ; then
        echo "Falta nombre de fichero .resultados"
        exit 1;
fi

NAME=`pwd | rev | cut -d'/' -f1  | rev`
[ -z $P_MAX ] && P_MAX=10
P=`seq 2 $P_MAX`
NP=`echo $P | tr " " "\n" | wc -l`

MAX_N=`cat $FILE | cut -d= -f3 | uniq | cut -d, -f1 | tail -n1`

DATA=`cat $FILE | grep "N=${MAX_N}, "`

tn=`echo "$DATA" | grep "P=1," | cut -d= -f4`

echo '\begin{table}'
echo '\begin{center}'
echo '\begin{tabular}{|c|c|c|c|} \cline{1-4}'
echo '\cellcolor[gray]{.9} $p$ &'
echo '\cellcolor[gray]{.9} Speedup $S(n,p)$ &'
echo '\cellcolor[gray]{.9} Eficiencia $E(n,p)$ &'
echo '\cellcolor[gray]{.9} Coste $C(n,p)$ \\ \hline'

for p in $P ; do
	tnp=`echo "$DATA" | grep "P=$p," | cut -d= -f4`
	snp=`echo "$tn / $tnp" | bc -l | sed "s|^\.\([0-9]*\)|0.\1|g"`
	enp=`echo "$snp / $p" | bc -l | sed "s|^\.\([0-9]*\)|0.\1|g"`
	cnp=`echo "$tnp * $p" | bc -l | sed "s|^\.\([0-9]*\)|0.\1|g"`
	tnp=`echo "scale=3; $tnp / 1" | bc -l | sed "s|^\.\([0-9]*\)$|0.\1|g"`
	snp=`echo "scale=3; $snp / 1" | bc -l | sed "s|^\.\([0-9]*\)$|0.\1|g"`
	enp=`echo "scale=3; $enp / 1" | bc -l | sed "s|^\.\([0-9]*\)$|0.\1|g"`
	cnp=`echo "scale=3; $cnp / 1" | bc -l | sed "s|^\.\([0-9]*\)$|0.\1|g"`
	echo "\\cellcolor[gray]{.9} $p & $snp & $enp & $cnp \\\\ \\hline"
done

echo '\end{tabular}'
echo "\\end{center}\\caption[Speedup, eficiencia y coste de $NAME]{Speedup, eficiencia y coste de $NAME con n=$MAX_N. El valor del tiempo secuencial \$t(n)=$tn\$ segundos}"
echo "\\end{table}\\label{tab:speedup_eficiancia_coste_$NAME}"
