
#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <sys/time.h>
#include <time.h>

int THREADS;

void mv(double *m,int fm,int cm,int ldm,double *v,int fv,double *w,int fw) {
  int i,j,iam,nprocs;
  double s;
  #pragma omp parallel private(iam,nprocs) 
  {
    nprocs=omp_get_num_threads();
    iam=omp_get_thread_num();
    #pragma omp master
      THREADS=nprocs;
    #pragma omp for private(i,s,j) schedule(static)
    for (i = 0; i < fm; i++) 
    {
      //printf("Soy thread %d, i=%d \n",iam,i);
      s=0.;
      for(j=0;j<cm;j++)
      {
        s+=m[i*ldm+j]*v[j];
      }
      w[i]=s;
    }
  }
}

void initialize(double *m,int t) {
  int i;
  for (i = 0; i < t; i++)
    m[i] = (double)(i);
}

void initializealea(double *m, int t) {
  int i;
  for (i = 0; i < t; i++)
    m[i] = (double)rand()/RAND_MAX;
}

void escribir(double *m, int fm,int cm,int ldm) {
  int i,j;
  for (i = 0; i < fm; i++) {
    for(j=0;j<cm;j++)
      printf("%.4lf ",m[i*ldm+j]);
    printf("\n");
  }
}



////////////////////////////////////////////////////////////////////////7
int main(int argc,char *argv[]) {
  int t,iN,fN,incN,i;
  double start,fin,tiempo,tiempo_clock,Mflops;
  double *a,*v,*w;
  struct timeval *tv;
  struct timezone *tz;
   int ti1,tf1,si,sf;
     

        if (argc<4)
        {
                printf(" Uso:  %s inicioN finN incrementoN \n\n",argv[0]);
                exit(1);
        }
  iN=atoi(argv[1]);
  fN=atoi(argv[2]);
  incN=atoi(argv[3]);
  for(t=iN;t<=fN;t+=incN) {
    a = (double *) malloc(sizeof(double)*t*t);
    v = (double *) malloc(sizeof(double)*t);
    w = (double *) malloc(sizeof(double)*t);
    initializealea(a,t*t);
    initializealea(v,t);

    //start=omp_get_wtime();
    start=clock();
    /*******************************/
    tv=(struct timeval *) malloc(sizeof(struct timeval));
    tz=(struct timezone *) malloc(sizeof(struct timezone));
    gettimeofday(tv,tz);
    si=(tv->tv_sec);
    ti1=(tv->tv_usec);
    ti1=si*1000000+ti1;
    /**************************************/            
    
    
    
    mv(a,t,t,t,v,t,w,t);



    fin=clock();
    //fin=omp_get_wtime();
    //tiempo=fin-start;
    tiempo_clock=(fin-start)/CLOCKS_PER_SEC;
         
    /***************************************/
    gettimeofday(tv,tz);
    sf=(tv->tv_sec);
    tf1=(tv->tv_usec);
    tf1=sf*1000000+tf1;
    tiempo=(tf1-ti1)/1000000.;       
    
    /***************************************/


    
    if(tiempo==0.) {
      printf("No hay suficiente precision\n");
    }
    else {
      Mflops=((2.*t*t)/tiempo)/1000000.;
      printf("[%s] P=%d, N=%d, S=%.6lf\n", argv[0], THREADS, t, tiempo);
      //printf("  threads %d, tamano %d tiempo_clock:%.6lf segundos: %.6lf \n",THREADS,t,tiempo_clock,tiempo);
      //printf("  threads %d, tamano %d segundos: %.6lf, Mflops: %.6lf, Mflops por thread: %.6lf\n\n\n",THREADS,t,tiempo,Mflops,Mflops/THREADS);
    }
        for(i=0;i<t;i++)
        {
                fprintf(stderr,"%f ",w[i]);
        }
    free(a);
    free(v);
    free(w);
  }
}

