#!/bin/bash

F=$1

if [ $# == 0 ] ; then
	echo "Falta nombre de fichero .resultados"
	exit 1;
fi

[ -z $P_MAX ] && P_MAX=10
N_MAX=`cat $F | cut -d= -f3 | cut -d, -f1 | sort | uniq | tail -n 1`
COMPILER=`echo $F | sed "s|.*_\([ig]cc\)-.*.resultados|\1|g"`

COL='|c|' ; for i in `seq 1 $P_MAX` ; do COL=${COL}c\| ; done

HEAD='\multicolumn{1}{|>{\columncolor[gray]{.9}}c|}{1}'
for i in `seq 2 10` ; do HEAD=$HEAD' & \multicolumn{1}{>{\columncolor[gray]{.9}}c|}{'$i'}' ; done

echo '\begin{table}'
echo '\begin{center}'
echo '\begin{scriptsize}'
echo '\begin{tabular}{'$COL'} \cline{2-'$(($P_MAX + 1))'}'
echo '\multicolumn{1}{c}{} & '${HEAD}' \\ \hline'

FILTER=`cat $F | grep  ", N=$N_MAX, " | sed "s|.* P=\(.*\), N=\(.*\), S=\(.*\)$|\1 ((2*\2^2)/10^6)/\3|g"`
FILE=`echo $F | sed "s|resultados|mflops|g"`
rm -f $FILE 2>/dev/null

echo -n '\cellcolor[gray]{.9} '$COMPILER
for p in `seq 1 $P_MAX` ; do
	FILTER2=`echo "$FILTER" | egrep "^$p " | cut -d' ' -f2`
	BC=`echo "scale=3;$FILTER2" | bc -l`
	
	echo -n " & $BC"
	echo "$p $BC" >>$FILE
done
echo ' \\ \hline'

CAPTION=`echo $F | tr '_' ' ' | tr '-' ' ' | cut -d'.' -f1`
echo '\end{tabular}'
echo '\end{scriptsize}'
echo '\end{center}\caption['$CAPTION']{'$CAPTION'}'
echo '\end{table}\label{tab:'$CAPTION'}'
