#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

int x;

int main(int argc,char *argv[]) {

	double start,fin,tiempo,Mflops;
	int numThreads, computacion;
	int tamBucle;
	int * r;

	if ( argc != 4 ) {
		printf ("ERROR: ejecutable tamBucle numThreads tamComputacion");
		return 0;
	}

	tamBucle=atoi(argv[1]);
	numThreads=atoi(argv[2]);
	computacion=atoi(argv[3]);

	r = (int *) malloc(sizeof(int)*numThreads);

	// Establecemos el numero de threads.
	omp_set_num_threads(numThreads);

	int i;

	start=omp_get_wtime();

	for ( i = 0; i<tamBucle;i++ ) {
		
		#pragma omp parallel
		{
			int k;

			int numThr = omp_get_thread_num();

			for(k=0;k<computacion;k++) {
				r[numThr] =  rand();
			}

			#pragma omp barrier
		}
	}

	fin=omp_get_wtime();

	tiempo=fin-start;

	// Asignamos para eliminar las optimizaciones erroneas del compilador.
	int aux;
	for ( i = 0; i<numThreads; i++ ) {
		aux = r[i];
	}

	if (tiempo == 0.)
		printf("[%s] P=%d, N=%d, S=0 - No hay suficiente precision\n", argv[0], numThreads ,tamBucle);
	else
		printf("[%s] P=%d, N=%d, S=%.6lf\n", argv[0], numThreads, tamBucle, tiempo);

}
