#include <stdio.h>
#include <stdlib.h>
#include <omp.h>


int main(int argc,char *argv[]) {

	double start,fin,tiempo,Mflops;
	int numThreads;
	int tamBucle, numTareas,computacion;
        int *r;

	if ( argc != 5 ) {
		printf ("ERROR: ejecutable tamBucle1 numTareas numThreads tamComputacion");
		return 0;
	}

	tamBucle=atoi(argv[1]);
	numTareas=atoi(argv[2]);
	numThreads=atoi(argv[3]);
	computacion=atoi(argv[4]);

        r = (int *) malloc(sizeof(int)*numTareas);

	// Establecemos el numero de threads.
	omp_set_num_threads(numThreads);

	int i, j, k;

	start=omp_get_wtime();

	for ( i = 0; i<tamBucle;i++ ) {

		#pragma omp parallel for private(j,k) firstprivate(computacion)
		for (j=0; j<numTareas; j++ ) 
		{
			for(k=0;k<computacion;k++) {
				r[j] = k;
			}
		}
	}

	fin=omp_get_wtime();

	tiempo=fin-start;

	// Asignamos para eliminar las optimizaciones erroneas del compilador.
	int aux;
	for ( i = 0; i<numTareas; i++ ) {
		aux = r[i];
	}

	// Mostramos informacion por pantalla.
        if (tiempo == 0.)
                printf("[%s] P=%d, N=%d, S=0 - No hay suficiente precision\n", argv[0], numThreads,numTareas);
        else
                printf("[%s] P=%d, N=%d, S=%.6lf\n", argv[0], numThreads, numTareas, tiempo);

}
