#!/bin/bash

[ -z "$N" ] && N="1 50 100 1000 5000"
NT=`echo "$N" | tr " " "\n" | wc -l`
[ -z $P_MAX ] && P_MAX=10
P=`seq 1 $P_MAX`

for F in *_[gi]cc-O?.resultados ; do

  OUT=`echo $F | cut -d'.' -f1`.tex
  echo '\begin{table}' >$OUT
  echo '\begin{center}' >>$OUT
  echo -n '\begin{tabular}{|' >>$OUT
  for i in 0 $N ; do 
	echo -n 'c|' >>$OUT
  done
  echo "} \cline{2-$(($NT+1))}" >>$OUT
  echo "\multicolumn{1}{c}{} & \multicolumn{$NT}{|>{\\color{white}\\columncolor[gray]{.4}}c|}{N}\\\ \\cline{1-$(($NT+1))}" >>$OUT

  echo -n "\multicolumn{1}{|>{\\color{white}\\columncolor[gray]{.4}}c|}{P}" >>$OUT

  for n in $N ; do
	echo -n " & \\multicolumn{1}{>{\\columncolor[gray]{.9}}c|}{$n}" >>$OUT
  done

  echo '\\ \hline' >>$OUT

  for p in $P ; do 
	FILAS=`cat $F | grep " P=$p, "`
	echo -n "\\cellcolor[gray]{.9} $p " >>$OUT
	for n in $N ; do
		SUBFILAS=`echo "$FILAS" | grep ", N=$n, "`
		CELDA=`echo "$SUBFILAS" | cut -d'=' -f4`
		echo -n "& $CELDA " >>$OUT
	done
	echo '\\ \hline' >>$OUT
  done

  L=`echo $F | cut -d'.' -f1 | tr '_' ' '`

  echo '\end{tabular}' >>$OUT
  echo "\\end{center}\\caption[$L]{$L}" >>$OUT
  echo "\\end{table}\\label{tab:$L}" >>$OUT
done
