#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

#define NUM_SECCIONES 4

int main(int argc,char *argv[]) {

	double start,fin,tiempo;
	int tamBucle, computacion;
        int *r;

	if ( argc != 3 ) {
		printf ("ERROR: ejecutable tamBucle1 tamComputacion");
		return 0;
	}

	tamBucle=atoi(argv[1]);
	computacion=atoi(argv[2]);

        r = (int *) malloc(sizeof(int)*NUM_SECCIONES);

	// Establecemos el numero de threads.
	omp_set_num_threads(NUM_SECCIONES);

	int i, j, k;

	start=omp_get_wtime();

	for ( i = 0; i<tamBucle;i++ ) {

		#pragma omp parallel sections private(j,k)
		{
				#pragma omp section
				{
					for ( k=0; k<computacion; k++) {
						r[0] = j+k;
					}
				}
				#pragma omp section
				{
					for ( k=0; k<computacion; k++) {
						r[1] = j+k;
					}
				}
				#pragma omp section
				{
					for ( k=0; k<computacion; k++) {
						r[2] = j+k;
					}
				}
				#pragma omp section
				{
					for ( k=0; k<computacion; k++) {
						r[3] = j+k;
					}
				}
		}
	}


	fin=omp_get_wtime();

	tiempo=fin-start;

	// Asignamos para eliminar las optimizaciones erroneas del compilador.
	int aux;
	for ( i = 0; i<NUM_SECCIONES; i++ ) {
		aux = r[i];
	}

	// Mostramos informacion por pantalla.
	if (tiempo == 0.)
		printf("[%s] P=%d, N=%d, S=0 - No hay suficiente precision\n", argv[0], NUM_SECCIONES,tamBucle);
	else
		printf("[%s] P=%d, N=%d, S=%.6lf\n", argv[0], NUM_SECCIONES, tamBucle, tiempo);
}
